<template>
  <div>
    <v-img
      :src="image"
      :aspect-ratio="16/9"
    >
      <v-container
        grid-list-md
        text-xs-center
      >
        <v-layout
          row
          wrap
          justify-space-around
        >
          <v-flex
            sm4
          >
            <v-card
              elevation="10"
              height="500"
            >
              <v-layout
                column
                wrap
                align-center
              >
                <v-container>
                  <v-layout
                    column
                    wrap
                    align-center
                    justify-center
                  >
                    <img
                      src="/img/e-logo.png"
                      height="100"
                      width="100">
                    <h1 class="display-1">Academic Grading System</h1>
                  </v-layout>
                </v-container>
                <!-- <v-divider class="my-3"/> -->
                <span
                  v-if="isValid == false"
                  style="color: red">Please enter a valid email address.(email@kmtil.ac.th)</span>
                <v-btn
                  v-if="!isSignIn"
                  :disabled="!isInit"
                  color="white"
                  small
                  @click="signIn"
                >
                  <v-avatar tile>
                    <v-img
                      :src="glogo"
                      height="25"
                      contain/>
                  </v-avatar>
                  <span style="color: grey">
                    Sign in with Google
                  </span>
                </v-btn>
                <v-btn
                  v-if="isSignIn"
                  :disabled="!isInit"
                  color="white"
                  small
                  @click="signOut"
                >
                  <v-avatar tile>
                    <v-img
                      :src="glogo"
                      height="25"
                      contain/>
                  </v-avatar>
                  <span style="color: grey">
                    Sign Out
                  </span>
                </v-btn>
                <!-- <v-divider class="my-3"/> -->
                <span style="color: lightgrey">Powered by Ethereum</span>
              </v-layout>
            </v-card>
          </v-flex>
        </v-layout>
      </v-container>
    </v-img>
    <v-dialog
      v-model="dialog"
      max-width="320"
      persistent
    >
      <v-card>
        <v-card-title class="headline font-weight-bold">Create PIN</v-card-title>
        <v-card-text class="title font-weight-bold text-xs-center">
          <v-form @submit.prevent="submitUser()">
            <v-text-field
              v-model="pin1"
              :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
              :rules="[rules.required, rules.min, rules.validateNumber]"
              :type="show1 ? 'text' : 'password'"
              name="pin1"
              label="PIN"
              hint="At least 6 characters [0-9]"
              counter="6"
              required
              @click:append="show1 = !show1"
            ></v-text-field>
            <v-text-field
              v-model="pin2"
              :append-icon="show2 ? 'mdi-eye' : 'mdi-eye-off'"
              :rules="[rules.required, rules.min, rules.pinMatch]"
              :type="show2 ? 'text' : 'password'"
              name="pin2"
              label="Confirm PIN"
              counter="6"
              required
              @click:append="show2 = !show2"
            ></v-text-field>
          </v-form>
        </v-card-text>

        <v-card-actions>
          <v-spacer/>
          <v-btn
            color="success"
            flat="flat"
            @click="submitUser ()"
          >
            SUBMIT
          </v-btn>
          <v-btn
            color="error"
            flat="flat"
            @click="signOut()"
          >
            CLOSE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { mapState, mapGetters, mapMutations } from 'vuex'

export default {
  name: 'GoogleLogin',
  data: () => ({
    isInit: false,
    isSignIn: false,
    isValid: null,
    isAdmin: false,
    logo: './img/logo.png',
    glogo: './img/g-logo.png',
    email: '',
    name: '',
    dialog: false,
    show1: false,
    show2: false,
    pin1: '',
    pin2: ''
  }),
  computed: {
    ...mapGetters('web3', ['alreadyAccount']),
    ...mapState('app', ['image', 'color']),
    inputValue: {
      get () {
        return this.$store.state.app.drawer
      },
      set (val) {
        this.setDrawer(val)
      }
    },
    items () {
      return this.$t('Layout.View.items')
    },
    rules () {
      return {
        required: v => !!v || 'Required.',
        min: v => v.length === 6 || 'Only 6 characters',
        pinMatch: v => v === this.pin1 || 'The PIN you entered don\'t match',
        validateNumber: v => !isNaN(Number(v)) || 'The PIN you entered must be number'
      }
    }
  },
  async mounted () {
    await this.$store.dispatch('web3/connectToWeb3')
    await this.$store.dispatch('web3/setContract')

    let that = this
    let checkGoogleAuthLoad = setInterval(async () => {
      that.isInit = that.$gAuth.isInit
      that.isSignIn = that.$gAuth.isAuthorized
      const isAuth = JSON.parse(localStorage.getItem('isAuthorized'))
      if (isAuth === null && that.$gAuth.isAuthorized) {
        await this.$gAuth.signOut()
        this.isSignIn = this.$gAuth.isAuthorized
      }

      if (that.isInit) { clearInterval(checkGoogleAuthLoad) }
    }, 1000)
  },
  methods: {
    ...mapMutations(['clearUserProfile', 'clearAlreadyAccount']),
    getAuthCode: function () {
      this.$gAuth.getAuthCode()
        .then(authCode => {
        }).then(response => {
          console.log(response)
        })
        .catch(err => {
          console.log(err)
        })
    },
    signIn: function () {
      this.$gAuth.signIn()
        .then(googleUser => {
          this.email = googleUser.getBasicProfile().getEmail()
          this.name = googleUser.getBasicProfile().getName()
          const payload = {
            email: this.email,
            name: this.name
          }
          localStorage.setItem('email', this.email)
          localStorage.setItem('lecturer', this.name)
          this.$store.dispatch('web3/checkAlreadyAccount', payload).then((result) => {
            if (result === '0x0000000000000000000000000000000000000000') {
              this.dialog = true
            } else {
              this.isSignIn = this.$gAuth.isAuthorized
              this.isValid = true
              this.$router.push('Home')
              // if (this.$route.query.from) { this.$router.replace(this.$route.query.from) } else { this.$router.push('Home') }
            }
          })
        })
        .catch(err => {
          this.isValid = false
          console.log(err)
        })
    },
    signOut: function () {
      this.$gAuth.signOut()
        .then(() => {
          this.dialog = false
          this.isSignIn = this.$gAuth.isAuthorized
          localStorage.removeItem('isAuthorized')
          localStorage.removeItem('isAdmin')
          localStorage.removeItem('studentCode')
          localStorage.removeItem('lecturer')
          localStorage.removeItem('email')
          localStorage.removeItem('name')
          localStorage.removeItem('address')
          this.clearUserProfile()
          this.clearAlreadyAccount()
          this.$router.push('Login')
        })
        .catch(err => {
          console.log(err)
        })
    },
    submitUser () {
      const payload = {
        email: this.email,
        name: this.name,
        pin: this.pin1
      }
      if (localStorage.getItem('isAdmin')) {
        this.$store.dispatch('web3/addTeacherAccount', payload)
        this.isSignIn = this.$gAuth.isAuthorized
        this.isValid = true
        this.$router.push('Home')
      } else {
        this.$store.dispatch('web3/addStudentAccount', payload)
        this.isSignIn = this.$gAuth.isAuthorized
        this.isValid = true
        this.$router.push('Home')
        // if (this.$route.query.from) { this.$router.replace(this.$route.query.from) } else { this.$router.push('Home') }
      }
    }
  }
}
</script>
